#include "common.h"
#include "photon.h"
#include "meshmanager.h"

extern PhotonMap *g_pPhotonMap;
extern MeshManager *g_pMeshManager;
extern int g_iNumberTracePasses;

extern bool g_bToggleGeneratePhotons;

void algorithm()
{
	int i;
	// Step 1 - Generate photons from the lights
	if(g_bToggleGeneratePhotons)
		g_pPhotonMap->generatePhotons();

	// Step 2 - Trace photons in the scene

	for(i=0; i<g_pMeshManager->getNumberMeshes(); i++)
		g_pPhotonMap->trace(g_pMeshManager->getMesh(i), g_iNumberTracePasses);

	// Step 3 - Build photon textures

	g_pPhotonMap->buildTextures();

	// Step 4 - Build the photon id texture

	for(i=0; i<g_pMeshManager->getNumberMeshes(); i++)
		g_pPhotonMap->buildPhotonIdTexture(g_pMeshManager->getMesh(i));

	// Step 5 - Set all streams and textures and set the vertex and the fragment programs

	//g_pPhotonMap->buildStreams();
}
