#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include <Windows.h>
#include "glut.h"

#include "timing.h"
#include "geometry.h"
#include "vector.h"
#include "photon.h"

//#define SLOW 1

#ifdef SLOW
#define VP_PROFILE
#define FP_PROFILE
#else
#define VP_PROFILE
#define FP_PROFILE
#endif

#define PERFORM_TIMING 1

#define MENU_QUIT					0
#define MENU_WIREFREAME_TOGGLE		1
#define MENU_PRINT_ID_BUFFER		2
#define MENU_PRINT_POW_BUFFER		3
#define MENU_PRINT_DIR_BUFFER		4
#define MENU_SHOW_PHOTON_DENSITY	5
#define MENU_SHOW_PHOTON_TRACE		6
#define MENU_PAUSE_MODE				7
#define MENU_NUMBER_PHOTONS_1		100
#define MENU_NUMBER_PHOTONS_64		101
#define MENU_NUMBER_PHOTONS_256		102

// LOD values - higher LOD means more tessellation
#define MAX_LOD	6
#define GRID_SIZE 0.25

#define MAX_PHOTON_DISTANCE 3

#define MAX_PHOTONS_PER_TRIANGLE 4
#define PHOTONID_SQUARE_SIZE     2
#define PHOTONS_PER_WORD         1


typedef enum
{
	X_AXIS = 0,
	Y_AXIS = 1,
	Z_AXIS = 2
}Orientation;

void initCg();
void reportError(char *string);
void initApp();

void seedg(int iSeedNumber = 0);
// return a float between 0-1
float rand01();
void normalize(float x, float y, float z, float &nx, float &ny, float &nz);
void createWall(Mesh *pMesh, int lodLevel);
void createBox(Mesh *pMesh, int lodLevel, float fScale, float fTransX, float fTransY, float fTransZ);
void createQuad();

// Drawing functions
void render();
void reshape(int w, int h);
void initGL();
bool initExtensions();
// Input functions
void mouseFunction(int x, int y);
void keyboardFunction(unsigned char c);

void drawObjectCg(Mesh *pMesh);
void simpleCg();
void algorithm();
float calculateArea(Vector3 &v1, Vector3 &v2, Vector3 &v3);
void renderString(int x, int &y, char *str);
void drawHUD();
void calculateFPS();
void drawPhotonDensity();
void drawPhotonTrace();
void generateCube(int iSize, float fXTrans, float fYTrans, float fZTrans);
void generateScene();
Vector3 reflection(Vector3 &kDir, Vector3 &kPos, Vector3 &kNormal);